"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var TableGeneratorComponent = /** @class */ (function () {
    function TableGeneratorComponent() {
        this.displayedColumns = [];
    }
    Object.defineProperty(TableGeneratorComponent.prototype, "classMap", {
        set: function (classMap) {
            var _this = this;
            classMap.map(function (item) {
                _this.classList += item + " ";
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableGeneratorComponent.prototype, "dataSourceMap", {
        set: function (dataSoruce) {
            this.dataSource = dataSoruce;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableGeneratorComponent.prototype, "columns", {
        set: function (columns) {
            this.isSub = this.isSuboperation(columns);
            this.dataColumns = columns;
            this.displayedColumns = this.generateDisplay(columns);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableGeneratorComponent.prototype, "rowClick", {
        set: function (event) {
            this.clickRowEvent = event;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableGeneratorComponent.prototype, "sortOptions", {
        set: function (value) {
            this.matSortActive = value.activeSort ? value.activeSort : this.dataColumns[0].name;
            this.sortChange = value.sortChange ? value.sortChange : null;
            this.sortDirection = value.direction ? value.direction : 'asc';
        },
        enumerable: true,
        configurable: true
    });
    TableGeneratorComponent.prototype.generateDisplay = function (data) {
        var array = [];
        data.map(function (item) {
            array.push(item.name);
        });
        return array;
    };
    TableGeneratorComponent.prototype.isSuboperation = function (columns) {
        if (columns[0].name === 'btnSuboperations' && columns[0].suboperationData) {
            this.suboperationsData = columns[0].suboperationData;
            return true;
        }
        return false;
    };
    TableGeneratorComponent.prototype.ngOnInit = function () { };
    __decorate([
        core_1.Input('classMap'),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], TableGeneratorComponent.prototype, "classMap", null);
    __decorate([
        core_1.Input('dataSource'),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], TableGeneratorComponent.prototype, "dataSourceMap", null);
    __decorate([
        core_1.Input('dataColumnsTable'),
        __metadata("design:type", Array),
        __metadata("design:paramtypes", [Array])
    ], TableGeneratorComponent.prototype, "columns", null);
    __decorate([
        core_1.Input('rowClick'),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], TableGeneratorComponent.prototype, "rowClick", null);
    __decorate([
        core_1.Input('sortOptions'),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], TableGeneratorComponent.prototype, "sortOptions", null);
    TableGeneratorComponent = __decorate([
        core_1.Component({
            selector: 'app-table-generator',
            templateUrl: './table-generator.component.html',
        }),
        __metadata("design:paramtypes", [])
    ], TableGeneratorComponent);
    return TableGeneratorComponent;
}());
exports.TableGeneratorComponent = TableGeneratorComponent;
//# sourceMappingURL=table-generator.component.js.map